<?php
function expert_fitness_trainer_header_settings( $wp_customize ) {
$selective_refresh = isset( $wp_customize->selective_refresh ) ? 'postMessage' : 'refresh';

    // Site Title Hide/ Show Setting // 
	$wp_customize->add_setting( 
		'expert_fitness_trainer_site_title_setting' , 
			array(
			'default' => 1,
			'sanitize_callback' => 'expert_fitness_trainer_sanitize_checkbox',
			'capability' => 'edit_theme_options',
		) 
	);
	
	$wp_customize->add_control(
	'expert_fitness_trainer_site_title_setting', 
		array(
			'label'	      => esc_html__( 'Hide / Show Site Title', 'expert-fitness-trainer' ),
			'section'     => 'title_tagline',
			'settings'    => 'expert_fitness_trainer_site_title_setting',
			'type'        => 'checkbox'
		) 
	);

	// Tagline Hide/ Show Setting // 
	$wp_customize->add_setting( 
		'expert_fitness_trainer_tagline_setting' , 
			array(
			'default' => '',
			'sanitize_callback' => 'expert_fitness_trainer_sanitize_checkbox',
			'capability' => 'edit_theme_options',
		) 
	);
	
	$wp_customize->add_control(
	'expert_fitness_trainer_tagline_setting', 
		array(
			'label'	      => esc_html__( 'Hide / Show Tagline', 'expert-fitness-trainer' ),
			'section'     => 'title_tagline',
			'settings'    => 'expert_fitness_trainer_tagline_setting',
			'type'        => 'checkbox'
		) 
	);

	$wp_customize->add_setting( 'Expert_Fitness_Trainer_upgrade_page_settings_9',
	    array(
	        'sanitize_callback' => 'sanitize_text_field'
	    )
    );
    $wp_customize->add_control( new Expert_Fitness_Trainer_Control_Upgrade(
        $wp_customize, 'Expert_Fitness_Trainer_upgrade_page_settings_9',
            array(
                'priority'      => 200,
                'section'       => 'title_tagline',
                'settings'      => 'Expert_Fitness_Trainer_upgrade_page_settings_9',
                'label'         => __( 'Expert Fitness Trainer Pro comes with additional features.', 'expert-fitness-trainer' ),
                'choices'       => array( __( '15+ Ready-Made Sections', 'expert-fitness-trainer' ), __( 'One-Click Demo Import', 'expert-fitness-trainer' ), __( 'WooCommerce Integrated', 'expert-fitness-trainer' ), __( 'Drag & Drop Section Reordering', 'expert-fitness-trainer' ),__( 'Advanced Typography Control', 'expert-fitness-trainer' ),__( 'Intuitive Customization Options', 'expert-fitness-trainer' ),__( '24/7 Support', 'expert-fitness-trainer' ), )
            )
        )
    ); 

	// Add the setting for logo width
	$wp_customize->add_setting(
	    'expert_fitness_trainer_logo_width',
	    array(
	        'sanitize_callback' => 'expert_fitness_trainer_sanitize_logo_width',
	        'priority'          => 2,
	    )
	);

	// Add control for logo width
	$wp_customize->add_control( 
	    'expert_fitness_trainer_logo_width',
	    array(
	        'label'     => __('Logo Width', 'expert-fitness-trainer'),
	        'section'   => 'title_tagline',
	        'type'      => 'number',
	        'input_attrs' => array(
	            'min'   => 1,
	            'max'   => 150,
	            'step'  => 1,
	        ),
	        'transport' => $selective_refresh,
	    )
	);

	/*=========================================
	Expert Fitness Trainer Site Identity
	=========================================*/
	$wp_customize->add_section(
        'title_tagline',
        array(
        	'priority'      => 1,
            'title' 		=> __('Site Identity','expert-fitness-trainer'),
			'panel'  		=> 'expert_fitness_trainer_frontpage_sections',
		)
    );

	$wp_customize->register_panel_type( 'Expert_Fitness_Trainer_WP_Customize_Panel' );
	$wp_customize->register_section_type( 'Expert_Fitness_Trainer_WP_Customize_Section' );

}
add_action( 'customize_register', 'expert_fitness_trainer_header_settings' );

if ( class_exists( 'WP_Customize_Panel' ) ) {
  	class Expert_Fitness_Trainer_WP_Customize_Panel extends WP_Customize_Panel {
	   public $panel;
	   public $type = 'expert_fitness_trainer_panel';
	   public function json() {

	      $array = wp_array_slice_assoc( (array) $this, array( 'id', 'description', 'priority', 'type', 'panel', ) );
	      $array['title'] = html_entity_decode( $this->title, ENT_QUOTES, get_bloginfo( 'charset' ) );
	      $array['content'] = $this->get_content();
	      $array['active'] = $this->active();
	      $array['instanceNumber'] = $this->instance_number;
	      return $array;
    	}
  	}
}

if ( class_exists( 'WP_Customize_Section' ) ) {
  	class Expert_Fitness_Trainer_WP_Customize_Section extends WP_Customize_Section {
	   public $section;
	   public $type = 'expert_fitness_trainer_section';
	   public function json() {

	      $array = wp_array_slice_assoc( (array) $this, array( 'id', 'description', 'priority', 'panel', 'type', 'description_hidden', 'section', ) );
	      $array['title'] = html_entity_decode( $this->title, ENT_QUOTES, get_bloginfo( 'charset' ) );
	      $array['content'] = $this->get_content();
	      $array['active'] = $this->active();
	      $array['instanceNumber'] = $this->instance_number;

	      if ( $this->panel ) {
	        $array['customizeAction'] = sprintf( 'Customizing &#9656; %s', esc_html( $this->manager->get_panel( $this->panel )->title ) );
	      } else {
	        $array['customizeAction'] = 'Customizing';
	      }
	      return $array;
    	}
  	}
}